// enums.cs
using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace HongliangSoft.Utilities.TaskSchedulers {
	///<summary>Pʂ̃gK\܂B</summary>
	public struct DailyTrigger {
		private short daysInterval;
		///<summary>gK̊Ԋu擾܂͐ݒ肵܂B</summary>
		///<value>\lB1 ɂ͂ł܂B</value>
		///<exception cref="ArgumentOutOfRangeException">1 lA܂ 65535 傫lw肳܂B</exception>
		public int DaysInterval{
			get { return (int)this.daysInterval; }
			set {
				if (value < 0 || value > 65535)
					throw new ArgumentOutOfRangeException("value", value, "1 lA܂ 65535 傫lw肳܂B");
				this.daysInterval = unchecked((short)value);
			}
		}
		///<summary>
		///gK̊Ԋuw肵ăCX^X쐬܂B
		///</summary>
		///<param name="daysInterval">gK̊Ԋu̓\ Int32 B</param>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="daysInterval"/> ɁA1 lA܂ 65535 傫lw肳܂B</exception>
		public DailyTrigger(int daysInterval) {
			if (daysInterval < 0 || daysInterval > 65535)
				throw new ArgumentOutOfRangeException("daysInterval", daysInterval, "1 lA܂ 65535 傫lw肳܂B");
			this.daysInterval = unchecked((short)daysInterval);
		}
	}
	///<summary>TPʂ̃gK\܂B</summary>
	public struct WeeklyTrigger {
		private short weeksInterval;
		private DaysOfWeek daysOfWeek;
		///<summary>gK̊Ԋu擾܂͐ݒ肵܂B</summary>
		///<value>ԊuT\lB</value>
		///<exception cref="ArgumentOutOfRangeException">1 lA܂ 65535 傫lw肳܂B</exception>
		public int WeeksInterval{
			get { return (int)this.weeksInterval; }
			set {
				if (value < 1 || value > 65535)
					throw new ArgumentOutOfRangeException("value", value, "1 lA܂ 65535 傫lw肳܂B");
				this.weeksInterval = unchecked((short)value);
			}
		}
		///<summary>T̂Lȗj擾܂͐ݒ肵܂B</summary>
		///<value>gKLȗj\ <see cref="DaysOfWeek"/> 񋓑̂̒l̑gݍ킹B</value>
		///<exception cref="InvalidEnumArgumentException"> <see cref="DaysOfWeek"/> ̑gݍ킹łB</exception>
		public DaysOfWeek DaysOfWeek{
			get { return this.daysOfWeek; }
			set {
				if (((short)value < 0) || ((short)value > 0x7F))
					throw new InvalidEnumArgumentException("value", (short)value, typeof(DaysOfWeek));
				this.daysOfWeek = value;
			}
		}
		///<summary>
		///Lȗjw肵āATsgK\CX^X쐬܂B
		///</summary>
		///<param name="daysOfWeek">gKLȗj\ <see cref="DaysOfWeek"/> 񋓑̂̒l̑gݍ킹B</param>
		///<exception cref="InvalidEnumArgumentException"><paramref name="daysOfWeek"/>  <see cref="DaysOfWeek"/> ̑gݍ킹łB</exception>
		public WeeklyTrigger(DaysOfWeek daysOfWeek) {
			if (((short)daysOfWeek < 0) || ((short)daysOfWeek > 0x7F))
				throw new InvalidEnumArgumentException("daysOfWeek", (short)daysOfWeek, typeof(DaysOfWeek));
			this.weeksInterval = 1;
			this.daysOfWeek = daysOfWeek;
		}
		///<summary>
		///gK̊ԊuƁALȗjw肵ăCX^X쐬܂B
		///</summary>
		///<param name="weeksInterval">ԊuT\lB</param>
		///<param name="daysOfWeek">gKLȗj\ <see cref="DaysOfWeek"/> 񋓑̂̒l̑gݍ킹B</param>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="weeksInterval"/>  1 lA܂ 65535 傫lw肳܂B</exception>
		///<exception cref="InvalidEnumArgumentException"><paramref name="daysOfWeek"/>  <see cref="DaysOfWeek"/> ̑gݍ킹łB</exception>
		public WeeklyTrigger(int weeksInterval, DaysOfWeek daysOfWeek) {
			if (((short)daysOfWeek < 0) || ((short)daysOfWeek > 0x7F))
				throw new InvalidEnumArgumentException("daysOfWeek", (short)daysOfWeek, typeof(DaysOfWeek));
			if (weeksInterval < 1 || weeksInterval > 65535)
				throw new ArgumentOutOfRangeException("weeksInterval", weeksInterval, "1 lA܂ 65535 傫lw肳܂B");
			this.weeksInterval = unchecked((short)weeksInterval);
			this.daysOfWeek = daysOfWeek;
		}
	}
	///<summary>Pʂ̃gK\܂B</summary>
	///<remarks>
	///  <para>Cӂ̌̑gݍ킹ACӂ̓̑gݍ킹̃gKłB</para>
	///</remarks>
	public struct MonthlyDateTrigger {
		///<summary>gKLȓ̑gݍ킹擾܂͐ݒ肵܂B</summary>
		///<value>ꂼ̓LΉrbgŕ\ Int32 ̒lB1 1 rbgځiŉʃrbgjA2 2 rbgځAccɑΉ܂BꂼA1 ̏ꍇ͗LA0 ̏ꍇ͖ɂȂ܂B</value>
		///<exception cref="ArgumentOutOfRangeException">0 lw肳܂B</exception>
		public int Days {
			get { return this.days; }
			set {
				if (value < 0)
					throw new ArgumentOutOfRangeException("value", value, "l 0 ɂ邱Ƃ͂ł܂B");
				this.days = value;
			}
		}
		///<summary>gKLȌ̑gݍ킹擾܂͐ݒ肵܂B</summary>
		///<value>gKLȌ\ <see cref="Months"/> 񋓑̂̒l̑gݍ킹B</value>
		///<exception cref="InvalidEnumArgumentException"> <see cref="Months"/> ̑gݍ킹łB</exception>
		public Months Months {
			get { return this.months; }
			set {
				if (((short)value < 0) || ((short)value > 0xFFF))
					throw new InvalidEnumArgumentException("value", (short)value, typeof(Months));
				this.months = value;
			}
		}
		///<summary>
		///w肵LȃgKǂ\l擾܂B
		///</summary>
		///<param name="day">LȃgKǂ擾tB1  31 ܂ł̊Ԃ̒lłB</param>
		///<returns>LȃgK̏ꍇ trueBłȂ falseB</returns>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="day"/> ɁA1 菬lA܂ 31 傫lw肳܂B</exception>
		public bool IsDayEnabled(int day) {
			if (day < 1 || day > 31)
				throw new ArgumentOutOfRangeException("day", day, "1  31 ܂ł̒lłȂ΂Ȃ܂B");
			return (this.days & (1 << (day - 1))) != 0;
		}
		///<summary>
		///w肵̃gKL܂͖ɐݒ肵܂B
		///</summary>
		///<param name="day">gK̗Lݒ肷tB1  31 ܂ł̊Ԃ̒lłB</param>
		///<param name="enabled">LƐݒ肷ꍇ true BƐݒ肷ꍇ false B</param>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="day"/> ɁA1 菬lA܂ 31 傫lw肳܂B</exception>
		public void SetDayEnabled(int day, bool enabled) {
			if (day < 1 || day > 31)
				throw new ArgumentOutOfRangeException("day", day, "1  31 ܂ł̒lłȂ΂Ȃ܂B");
			this.days = enabled ? (this.days | (1 << (day - 1))) : (this.days & ~(1 << (day - 1)));
		}
		///<summary>
		///w肵zɊ܂܂邻ꂼ̓tɂāALɐݒ肵܂BIvVŁAzɊ܂܂Ȃt𖳌ɐݒ肷邱Ƃł܂B
		///</summary>
		///<param name="enabledDays">Lɂt Int32 ̔zB</param>
		///<param name="setDisabledOtherDays"><paramref name="enabledDyas"/> Ɋ܂܂Ȃ𖳌ɂꍇ true Bfalse ɂꍇAƂƂ̐ݒc܂B</param>
		///<exception cref="ArgumentNullException"><paramref name="enabledDays"/>  null w肳܂B</exception>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="enabledDays"/> ̒ɁA1 菬lA܂ 31 傫l܂܂Ă܂B</exception>
		public void SetDaysEnabled(int[] enabledDays, bool setDisabledOtherDays) {
			if (enabledDays == null)
				throw new ArgumentNullException("enabledDays", "null ɂ邱Ƃ͂ł܂D");
			int value = setDisabledOtherDays ? 0 : this.days;
			foreach (int day in enabledDays) {
				if (day < 1 || day > 31)
					throw new ArgumentOutOfRangeException("day", day, "1  31 ܂ł̒lłȂ΂Ȃ܂B");
				value |= (1 << (day - 1));
			}
			this.days = value;
		}
		///<summary>
		///LɂȂĂt̔zԂ܂B
		///</summary>
		///<returns>LɂȂĂt̔zB</returns>
		public int[] GetDaysEnabled() {
			uint bits = (uint)this.days; //Ărbg𐔂p
			bits = ((bits & 0xAAAAAAAA) >> 1) + (bits & 0x55555555);
			bits = ((bits & 0xCCCCCCCC) >> 2) + (bits & 0x33333333);
			bits = ((bits & 0xF0F0F0F0) >> 4) + (bits & 0x0F0F0F0F);
			bits = ((bits & 0xFF00FF00) >> 8) + (bits & 0x00FF00FF);
			bits = ((bits & 0xFFFF0000) >>16) + (bits & 0x0000FFFF);
			int[] retval = new int[bits];
			int index = 0;
			for (int i = 0; i < 31; i++) {
				if (((this.days >> i) & 1) == 1)
					retval[index++] = i;
			}
			return retval;
		}
		private int days;
		private Months months;
	}
	///<summary>PʂƏTPʂgݍ킹gK\܂B</summary>
	///<remarks>
	///  <para>Cӂ̌ACӂ̏TACӂ̗j̃gKłB</para>
	///</remarks>
	public struct MonthlyDayOfWeekTrigger {
		///<summary>gKLȏT擾܂͐ݒ肵܂B</summary>
		///<values>gKLȏT\ <see cref="WhichWeek"/> 񋓑̂̒l̈B̒l͑gݍ킹邱Ƃ͂ł܂B</values>
		///<exception cref="InvalidEnumArgumentException"> <see cref="WhichWeek"/> ̒lłB</exception>
		public WhichWeek WhichWeek {
			get { return this.whichWeek; }
			set {
				if (!Enum.IsDefined(typeof(WhichWeek), value))
					throw new InvalidEnumArgumentException("value", (short)value, typeof(WhichWeek));
				this.whichWeek = value;
			}
		}
		///<summary>T̂ŗLȗj̑gݍ킹擾܂͐ݒ肵܂B</summary>
		///<values>gKLȗj\ <see cref="DaysOfWeek"/> 񋓑̂̒lB</values>
		///<exception cref="InvalidEnumArgumentException"> <see cref="DaysOfWeek"/> ̑gݍ킹łB</exception>
		public DaysOfWeek DaysOfWeek {
			get { return this.daysOfWeek; }
			set {
				if ((short)value < 0 || (short)value > 0x7F)
					throw new InvalidEnumArgumentException("value", (short)value, typeof(DaysOfWeek));
				this.daysOfWeek = value;
			}
		}
		///<summary>gKLȌ̑gݍ킹擾܂͐ݒ肵܂B</summary>
		///<values>gKLȌ\ <see cref="Months"/> 񋓑̂̒lB</values>
		///<exception cref="InvalidEnumArgumentException"> <see cref="Months"/> ̑gݍ킹łB</exception>
		public Months Months {
			get { return this.months; }
			set {
				if ((short)value < 0 || (short)value > 0xFFF)
					throw new InvalidEnumArgumentException("value", (short)value, typeof(Months));
				this.months = value;
			}
		}
		///<summary>
		///LȌATAjw肵ăCX^X쐬܂B
		///</summary>
		///<param name="months">LȌ\ <see cref="Months"/> ̒lB</param>
		///<param name="whichWeek">LȏT\ <see cref="WhichWeek"/> ̒lB̒l͑gݍ킹܂B</param>
		///<param name="daysOfWeek">Lȗj\ <see cref="DaysOfWeek"/> ̒lB</param>
		///<exception cref="InvalidEnumArgumentException"> <see cref="Months"/> ̑gݍ킹łB܂́A <see cref="WhichWeek"/> ̒lłB܂́A <see cref="DaysOfWeek"/> ̑gݍ킹łB</exception>
		public MonthlyDayOfWeekTrigger(Months months, WhichWeek whichWeek, DaysOfWeek daysOfWeek) {
			if ((short)months < 0 || (short)months > 0xFFF)
				throw new InvalidEnumArgumentException("months", (short)months, typeof(Months));
			if (!Enum.IsDefined(typeof(WhichWeek), whichWeek))
				throw new InvalidEnumArgumentException("whichWeek", (short)whichWeek, typeof(WhichWeek));
			if ((short)daysOfWeek < 0 || (short)daysOfWeek > 0x7F)
				throw new InvalidEnumArgumentException("daysOfWeek", (short)daysOfWeek, typeof(DaysOfWeek));
			this.months = months;
			this.whichWeek = whichWeek;
			this.daysOfWeek = daysOfWeek;
		}
		private WhichWeek whichWeek;
		private DaysOfWeek daysOfWeek;
		private Months months;
	}
}
